#include <stdio.h>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/names.h>

void print_event(Fl_Widget *w,int e)
{
  static int last_event = -1;
  static int num = 0;
  if (e == last_event && (e == FL_DND_DRAG || e == FL_MOVE || e == FL_DRAG))
    return;
  last_event = e;
  num++;
  printf(
    "%4d - %-12.12s, Event: %2d - %s\n",
    num,
    w->label(),
    e,
    fl_eventnames[e]);
  fflush(stdout);
}

class TestWindow : public Fl_Window
{
  int handle(int e)
  {
    int ret = 0;
    if (e == FL_ENTER)
      ret = 1;
    else if (e == FL_LEAVE)
      ret = 1;
    else if (e == FL_DND_ENTER)
    {
      print_event(this, e);
      color(FL_YELLOW);
      redraw();
      ret = 1;
    }
    else if (e == FL_DND_LEAVE)
    {
      print_event(this, e);
      color(FL_GRAY);
      redraw();
      ret = 1;
    }
    else if (e == FL_DND_DRAG)
    {
      print_event(this, e);
      ret = 1;
    }
    return (Fl_Window::handle(e) | ret);
  }

public:
  TestWindow(int w, int h, const char *c) : Fl_Window(w, h, c) { }
};

int main(int argc, char **argv)
{
  TestWindow window(400, 400, "outer");
  window.show(argc, argv);
  return Fl::run();
}
